///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

#ifndef MobObjectObjH
#define MobObjectObjH
//---------------------------------------------------------------------------

#include <ComCtrls.hpp>

//...
//   ...
const DWORD Obj_Sgn_BodyTextures = 45069;       //(0D B0 00 00) // 
const DWORD Obj_Sgn_PlayerNumber = 45073;       //(11 B0 00 00) // .
const DWORD Obj_Sgn_ObjectID = 45058;           //(02 B0 00 00) //ID 
const DWORD Obj_Sgn_ObjectType = 45059;         //(03 B0 00 00) // .
const DWORD Obj_Sgn_ScriptVariableName = 45060; //(04 B0 00 00) // 
const DWORD Obj_Sgn_ModelName = 45062;          //(06 B0 00 00) // 3-.
const DWORD Obj_Sgn_Name2 = 45070;              //(0E B0 00 00) //     .
const DWORD Obj_Sgn_FirstTexture = 45063;       //(07 B0 00 00) // 
const DWORD Obj_Sgn_SecondTexture = 45064;      //(08 B0 00 00) // 
const DWORD Obj_Sgn_UnknownStr1 = 45071;        //(0F B0 00 00) // .
const DWORD Obj_Sgn_LoadCoords = 45065;         //(09 B0 00 00) // .
const DWORD Obj_Sgn_Rotation = 45066;           //(0A B0 00 00) // .
const DWORD Obj_Sgn_IsQuestUnit = 45075;        //(13 B0 00 00) //    .
const DWORD Obj_Sgn_ShowShadow = 45076;         //(14 B0 00 00) // -     .
const DWORD Obj_Sgn_UncnDw2 = 45074;            //(12 B0 00 00) // dw.
const DWORD Obj_Sgn_QuestLightStr = 45078;      //(16 B0 00 00) //-    
const DWORD Obj_Sgn_Complection = 45068;          //(0C B0 00 00) //

//  ...
class TMob;

//  ...
class TObjectObjBlock //    .
{
  public:
    DynamicArray <String> *BodyTextures;  //    -   .
    byte PlayerNumber;           // ,   .
    DWORD ObjectID;              //ID .
    DWORD ObjectType;            // .
    String ScriptVariableName;   //   .     .
    String ModelName;            // 3-.
    String Name2;                //     .
    String FirstTexture;         //  (  ).
    String SecondTexture;        //  (  ,  default0).
    String UnknownStr1;          // .   none.
    float LoadX;                 //,    .
    float LoadY;                 //  --"--
    float LoadZ;                 //  --"--
    float RotationW;             // .
    float RotationX;             //  --"--
    float RotationY;             //  --"--
    float RotationZ;             //  --"--
    byte IsQuestUnit;            //    .
    byte ShowShadow;             // -     .
    DWORD UncnDw2;               // dw.
    String QuestLightStr;        //-    .
    float ComplectionStrength;     // ().
    float ComplectionDex;          // ().
    float ComplectionTall;         // .

    // ...
    DWORD GetBlockSize();        //       .
    byte* GenBlock(DWORD& BlockSize);            // ...
    bool ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj);   //     .
    void GenBasePart(byte *Result);    //   ...
};

typedef TObjectObjBlock* PObjectObjBlock;   //  %).

#endif
